#include <AS.h>

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Str.h>
#include <Cytoplasm/Log.h>
#include <Cytoplasm/Uri.h>

#include <string.h>
#include <stdlib.h>

#include <Matrix.h>

bool
ASPing(const ParseeConfig *conf)
{
    HttpClientContext *ctx = NULL;
    HashMap *json = NULL;
    char *path;
    bool ret;
    if (!conf)
    {
        return false;
    }

    path = StrConcat(3,
        "/_matrix/client/v1/appservice/",
        "Parsee%20XMPP",
        "/ping"
    );
    ctx = ParseeCreateRequest(
        conf, 
        HTTP_POST, path
    );
    Free(path);
    json = HashMapCreate();
    ASAuthenticateRequest(conf, ctx);
    ret = ParseeSetRequestJSON(ctx, json) == HTTP_OK;
    HttpClientContextFree(ctx);
    JsonFree(json);

    return ret;
}
