#include <AS.h>

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Str.h>
#include <Cytoplasm/Log.h>
#include <Cytoplasm/Uri.h>

#include <string.h>
#include <stdlib.h>

#include <Matrix.h>

bool
ASRegisterUser(const ParseeConfig *conf, char *user)
{
    HttpClientContext *ctx = NULL;
    HashMap *json = NULL;
    HttpStatus status;
    if (!conf || !user)
    {
        return false;
    }

    /* Create user. We don't actually care about the value as we can 
     * masquerade, as long as it exists. */
    ctx = ParseeCreateRequest(
        conf, 
        HTTP_POST, "/_matrix/client/v3/register"
    );
    json = HashMapCreate();

    HashMapSet(json,"type",JsonValueString("m.login.application_service"));

    user = ParseeGetLocal(user);
    HashMapSet(json,"username",JsonValueString(user));

    ASAuthenticateRequest(conf, ctx);
    status = ParseeSetRequestJSON(ctx, json);

    HttpClientContextFree(ctx);
    JsonFree(json);

    Free(user);

    return status == HTTP_OK;
}
