#include <AS.h>

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Str.h>
#include <Cytoplasm/Log.h>
#include <Cytoplasm/Uri.h>

#include <string.h>
#include <stdlib.h>

#include <Matrix.h>

void
ASSetState(const ParseeConfig *conf, char *id, char *type, char *key, char *mask, HashMap *state)
{
    HttpClientContext *ctx = NULL;
    char *path;
    if (!conf || !id || !type || !mask || !state)
    {
        JsonFree(state);
        return;
    }

    path = StrConcat(9, 
        "/_matrix/client/v3/rooms/", id, "/state/",
        type, "/", key, "?", "user_id=", mask
    );

    ctx = ParseeCreateRequest(conf, HTTP_PUT, path);
    Free(path);
    ASAuthenticateRequest(conf, ctx);
    ParseeSetRequestJSON(ctx, state);
        
    HttpClientContextFree(ctx);
    JsonFree(state);
}

