#include <Routes.h>

#include <Cytoplasm/Cytoplasm.h>
#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Str.h>

#include <Matrix.h>
#include <Bot.h>
#include <AS.h>

CommandHead(CmdStats, cmd, argp)
{
    ParseeCmdArg *args = argp;
    ParseeData *data = args->data;
    HashMap *event = args->event;
    size_t congestion = ParseeCongestion();
    size_t alloc = MemoryAllocated();
    size_t kb = alloc   >> 10;
    size_t mb = kb      >> 10;
    size_t gb = mb      >> 10;
    size_t min = gb ? gb : (mb ? mb : (kb ? kb : alloc));
    char *unit = gb ? "GB" : (mb ? "MB" : (kb ? "KB" : "B"));

    BotInitialise();


    ReplySprintf("Information for %s v%s (Cytoplasm %s)",
        NAME, VERSION, CytoplasmGetVersionStr()
    );

    ReplySprintf("- Memory used: %d%s (reported by Cytoplasm)",
        (int) min, unit
    );
    ReplySprintf("- Unprocessed stanzas: %d",
        (int) congestion
    );
    ReplySprintf("- Source code and licensing information: %s",
        REPOSITORY
    );
    ReplyBasic("*Written with a shoelace and UHU glue by LDA <3 !*");

    BotDestroy();

    (void) cmd;
}
