#include <Parsee.h>

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Sha.h>

static char *
ToHex(unsigned char *input, size_t length)
{
    char *hex = Malloc(length * 2 + 1);
    size_t i;

    for (i = 0; i < length; i++)
    {
        const char *table =
            "0123456789abcdef";
        unsigned char byte = input[i];
        hex[2 * i] = table[(byte >> 4) & 0xF];
        hex[2*i+1] = table[(byte >> 0) & 0xF];
    }

    hex[length * 2] = '\0';

    return hex;
}

char *
ParseeSHA256(char *string)
{
    unsigned char *sha;
    char *returnString;
    if (!string)
    {
        return NULL;
    }

    sha = Sha256(string);
    returnString = ToHex(sha, 32);
    Free(sha);

    return returnString;
}
char *
ParseeSHA1(char *string)
{
    unsigned char *sha;
    char *returnString;
    if (!string)
    {
        return NULL;
    }

    sha = Sha1(string);
    returnString = ToHex(sha, 20);
    Free(sha);

    return returnString;
}
