#include <Parsee.h>

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Log.h>
#include <Cytoplasm/Str.h>

void
ParseeGenerateHelp(const Argument *list)
{
    if (!list)
    {
        return;
    }

    while (!list->end)
    {
        char *str = list->value_req ?
            StrConcat(3, " [", list->value_descr, "]") :
            StrDuplicate("");
        Log(LOG_INFO, "-%c%s", list->argument, str);
        LogConfigIndent(LogConfigGlobal());
        Log(LOG_INFO, "%s", list->description);
        LogConfigUnindent(LogConfigGlobal());
        list++;

        Free(str);
    }
    return;
}
char *
ParseeGenerateGetopt(const Argument *list)
{
    char *ret = NULL, *tmp = NULL;
    if (!list)
    {
        return NULL;
    }

    while (!list->end)
    {
        char buffer[3] = {
            list->argument, list->value_req ? ':' : '\0',
            '\0'
        };

        tmp = ret;
        ret = StrConcat(2, ret, buffer);
        Free(tmp);

        list++;
    }
    return ret;
}
