#include <Parsee.h>

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Str.h>

#include <Unistring.h>

#include <stdbool.h>
#include <string.h>
    
int
ParseeFindDatastart(char *data)
{
    char *startline;
    bool found = false;
    if (!data)
    {
        return 0;
    }

    startline = data;
    while (startline)
    {
        char *endline = strchr(startline, '\n');

        if (*startline != '>')
        {
            found = true;
            break;
        }

        startline = endline ? endline + 1 : NULL;
    }

    if (!found)
    {
        return 0;
    }

    return (int) (startline - data);
}
int 
ParseeFindDatastartU(char *data)
{
    Unistr *str;
    size_t ret;
    if (!data)
    {
        return 0;
    }

    str = UnistrCreate(data);
    ret = UnistrGetOffset(str, (uint32_t) '>');
    UnistrFree(str);

    return (int) ret;
}

char *
ParseeStringifyDate(uint64_t millis)
{
    uint64_t rest = millis;
    uint64_t hours, minutes, seconds;
    char *hs, *ms, *ss, *out;
    
    hours = rest / (1 HOURS);
    rest = rest % (1 HOURS);

    minutes = rest / (1 MINUTES);
    rest = rest % (1 MINUTES);

    seconds = rest / (1 SECONDS);

    hs = StrInt(hours);
    ms = StrInt(minutes);
    ss = StrInt(seconds);

    out = StrConcat(8,
        hours ? hs : "",
        hours ? " hours" : "",
        (hours && minutes) ? ", " : "",

        minutes ? ms : "",
        minutes ? " minutes" : "",
        (minutes && seconds) ? ", " : "",

        seconds ? ss : "",
        seconds ? " seconds" : ""
    );
    Free(hs);
    Free(ms);
    Free(ss);

    return out;
}
