#include <Parsee.h>

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Str.h>

bool
ParseeIsCompatible(char *ver1, char *ver2)
{
    char *major1 = NULL;
    char *major2 = NULL;
    char *tmp;
    if (!ver1 || !ver2)
    {
        return false;
    }

    /* Check if one of them is a "flipped"(joke) version. If so,
     * then the user should definitely NOT try funny things with
     * their data. */
    if (*ver1 == '-' || *ver2 == '-')
    {
        return false;
    }

#define GetMajor(v) do \
    { \
        while (*ver##v != '.') \
        { \
            char cb[2]; \
            cb[0] = *ver##v; \
            cb[1] = '\0'; \
            tmp = major##v; \
            major##v = StrConcat(2, major##v, cb); \
            Free(tmp); \
            ver##v++; \
        } \
    } \
    while (0)

    GetMajor(1);
    GetMajor(2);

    if (!StrEquals(major1, major2))
    {
        Free(major1);
        Free(major2);
        return false;
    }

    Free(major1);
    Free(major2);
    return true;
}
