#include <Cytoplasm/HashMap.h>
#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Json.h>
#include <Cytoplasm/Util.h>
#include <Cytoplasm/Str.h>
#include <Cytoplasm/Log.h>

#include <XMPPFormTool.h>
#include <XMPPCommand.h>
#include <Parsee.h>
#include <XMPP.h>
#include <XML.h>

void
AdminsCallback(XMPPCommandManager *m, char *from, XMLElement *form, XMLElement *out)
{
    ParseeData *data = XMPPGetManagerCookie(m);
    size_t i;
    XMLElement *x;
    XMLElement *title;
    XMLElement *reported, *item, *field, *value, *txt;

    x = XMLCreateTag("x");
    title = XMLCreateTag("title");

    SetTitle(x, "Parsee administrators");

    XMLAddChild(x, title);

    XMLAddAttr(x, "xmlns", "jabber:x:data");
    XMLAddAttr(x, "type", "result");
    {
        DbRef *ref = DbLock(data->db, 1, "admins");
        Array *admins = GrabArray(DbJson(ref), 1, "admins");

        reported = XMLCreateTag("reported");
        XMLAddChild(x, reported);
        
        /* Report */
        Report("admins", "Administrator globs");

        /* Set */
        for (i = 0; i < ArraySize(admins); i++)
        {
            char *glob = JsonValueAsString(ArrayGet(admins, i));
            BeginItem();
            SetField("admins", glob);
            EndItem();
        }
        DbUnlock(data->db, ref);
    }
    XMLAddChild(out, x);

    (void) form;
    (void) from;
}
