#include <Cytoplasm/HashMap.h>
#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Json.h>
#include <Cytoplasm/Util.h>
#include <Cytoplasm/Str.h>
#include <Cytoplasm/Log.h>

#include <XMPPFormTool.h>
#include <XMPPCommand.h>
#include <Parsee.h>
#include <XMPP.h>
#include <XML.h>

void
CleanCallback(XMPPCommandManager *m, char *from, XMLElement *form, XMLElement *out)
{
    ParseeData *data = XMPPGetManagerCookie(m);
    char *trimmed = ParseeTrimJID(from);

    if (!ParseeIsAdmin(data, trimmed))
    {
        SetNote("error", "User is not authorised to execute command.");

        Free(trimmed);
        return;
    }
    Free(trimmed);

    ParseeCleanup(data);
    /* TODO: Cleanup old sessions? */
    SetNote("info", "Parsee data was sucessfully cleant up.");

    (void) form;
}
