#include <Cytoplasm/HashMap.h>
#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Json.h>
#include <Cytoplasm/Util.h>
#include <Cytoplasm/Str.h>
#include <Cytoplasm/Log.h>

#include <XMPPFormTool.h>
#include <XMPPCommand.h>
#include <Parsee.h>
#include <XMPP.h>
#include <XML.h>

void
MUCInformationID(XMPPCommandManager *m, char *from, XMLElement *form, XMLElement *out)
{
    ParseeData *data = XMPPGetManagerCookie(m);
    char *muc = ParseeTrimJID(from);
    char *chat_id = ParseeGetFromMUCID(data, muc);
    char *room_id = ParseeGetRoomID(data, chat_id);
    char *msg = StrConcat(5, 
        "The MUC ", muc, " is bridged to ", room_id, "."
    );

    SetNote("info", msg);

    Free(muc);
    Free(msg);
    Free(room_id);
    Free(chat_id);
    (void) form;
}
void
MUCInformationCID(XMPPCommandManager *m, char *from, XMLElement *form, XMLElement *out)
{
    ParseeData *data = XMPPGetManagerCookie(m);
    char *muc = ParseeTrimJID(from);
    char *chat_id = ParseeGetFromMUCID(data, muc);
    char *msg = StrConcat(5, 
        "The MUC ", muc, "'s internal ID is ", chat_id, "."
    );

    SetNote("info", msg);

    Free(muc);
    Free(msg);
    Free(chat_id);
    (void) form;
}
