#include <stdbool.h>
#include <string.h>

#include "XMPPThread/internal.h"

/* Performs i;octet collation. */
int
ICollate(unsigned char *cata, unsigned char *catb)
{
    size_t al = cata ? strlen((char *) cata) : 0;
    size_t bl = catb ? strlen((char *) catb) : 0;

    if (!al && !bl)
    {
        return 0;
    }
    while (true)
    {
        if (!al && bl)
        {
            return -1;
        }
        else if (al && !bl)
        {
            return 1;
        }

        if (*cata == *catb)
        {
            cata++;
            catb++;
            al--;
            bl--;
            continue;
        }
        else if (*cata < *catb)
        {
            return -1;
        }
        return 1;
    }
    return 0;
}

int 
IdentitySort(void *idap, void *idbp)
{
    XMPPIdentity *ida = idap;
    XMPPIdentity *idb = idbp;
    unsigned char *cata = (unsigned char *) ida->category;
    unsigned char *catb = (unsigned char *) idb->category;

    return ICollate(cata, catb);
}
