#include "XMPPThread/internal.h"

#include <Cytoplasm/Memory.h>
#include <Cytoplasm/Json.h>

#include <StringStream.h>

HashMap *
ShoveStanza(HashMap *content, XMLElement *stanza)
{
    char *encoded_stanza = NULL;
    Stream *str_writer = StrStreamWriter(&encoded_stanza);
    if (!stanza || !content)
    {
        StreamClose(str_writer);
        return content;
    }

    XMLEncode(str_writer, stanza);
    StreamFlush(str_writer);
    StreamClose(str_writer);

    JsonValueFree(HashMapSet(content, 
        "at.kappach.at.parsee.stanza",
        JsonValueString(encoded_stanza)
    ));
    JsonValueFree(HashMapSet(content, 
        "at.kappach.at.parsee.id",
        JsonValueString(HashMapGet(stanza->attrs, "id"))
    ));

    Free(encoded_stanza);
    return content;
}

