#ifndef PARSEE_COMMAND_H
#define PARSEE_COMMAND_H
/*-*
 * A Matrix command manager (with a JCL/dd-style format).
 * -----------
 * Written-By: LDA */

#include <Cytoplasm/HashMap.h>

typedef struct Command {
    char *command;
    HashMap *arguments;
} Command;

typedef struct CommandRouter CommandRouter;
typedef void (*CommandRoute)(Command *cmd, void *data);

extern CommandRouter * CommandCreateRouter(void);
extern void CommandAddCommand(CommandRouter *rter, char *c, CommandRoute rte);
extern void RouteCommand(CommandRouter *rter, Command *cmd, void *data);
extern void CommandFreeRouter(CommandRouter *rter);

extern Command * CommandParse(char *cmd);
extern void CommandFree(Command *command);
#endif
