#ifndef PARSEE_STANZABUILDER_H
#define PARSEE_STANZABUILDER_H

#include <XMPP.h>
#include <XML.h>

typedef struct StanzaBuilder StanzaBuilder;

extern StanzaBuilder * CreateStanzaBuilder(char *from, char *to, char *id);
extern StanzaBuilder * SetStanzaType(StanzaBuilder *builder, char *type);
extern StanzaBuilder * SetStanzaBody(StanzaBuilder *builder, char *body);
extern StanzaBuilder * SetStanzaReply(StanzaBuilder *builder, char *st, char *se);
extern StanzaBuilder * SetStanzaEdit(StanzaBuilder *builder, char *to);
extern StanzaBuilder * SetStanzaLink(StanzaBuilder *builder, char *oob);
extern StanzaBuilder * SetStanzaID(StanzaBuilder *builder, char *id);
extern StanzaBuilder * SetStanzaXParsee(StanzaBuilder *builder, HashMap *e);
extern StanzaBuilder * AddStanzaElem(StanzaBuilder *builder, XMLElement *item);
extern XMLElement    * ExportStanza(StanzaBuilder *builder);
extern void WriteoutStanza(StanzaBuilder *builder, XMPPComponent *jabber, size_t max);
extern void DestroyStanzaBuilder(StanzaBuilder *builder);

#endif
